﻿using System;
using System.Collections.ObjectModel;
using System.Linq;
using System.Xml.Linq;
using Telerik.Windows.Controls;
using System.ComponentModel.DataAnnotations;

namespace Telerik.Windows.Examples.TreeListView
{
    public class FolderViewModel : ViewModelBase
    {
        private string name;
        private bool isEmpty;
        private DateTime createdOn;
        private ObservableCollection<FolderViewModel> items;
        private ObservableCollection<FolderViewModel> itemsOnDemand;
        private readonly XElement folderElement;

        public FolderViewModel(string name, bool isEmpty, DateTime createdOn, XElement element)
        {
            this.Name = name;
            this.IsEmpty = isEmpty;
            this.folderElement = element;
            this.CreatedOn = createdOn;
        }

        public string Name
        {
            get
            {
                return this.name;
            }
            set
            {
                this.name = value;
            }
        }

        public DateTime CreatedOn
        {
            get
            {
                return this.createdOn;
            }
            set
            {
                this.createdOn = value;
            }
        }

        [Display(AutoGenerateField = false)]
        public bool IsEmpty
        {
            get
            {
                return this.isEmpty;
            }
            private set
            {
                this.isEmpty = value;
            }
        }

        [Display(AutoGenerateField = false)]
        public ObservableCollection<FolderViewModel> Items
        {
            get
            {
                if (this.items == null)
                {
                    this.items = new ObservableCollection<FolderViewModel>(from f in this.folderElement.Elements("folder")
                                                                           select new FolderViewModel(
                                                                               f.Attribute("Name").Value,
                                                                               bool.Parse(f.Attribute("IsEmpty").Value),
                                                                               DateTime.Parse(f.Attribute("CreationTime").Value, System.Globalization.CultureInfo.InvariantCulture), 
                                                                               f
                                                                           ));
                }

                return this.items;
            }
        }

        [Display(AutoGenerateField = false)]
        public ObservableCollection<FolderViewModel> ItemsOnDemand
        {
            get
            {
                return this.itemsOnDemand;
            }
            private set
            {
                if (this.itemsOnDemand != value)
                {
                    this.itemsOnDemand = value;

                    OnPropertyChanged("ItemsOnDemand");
                }
            }
        }

        public void LoadChildren()
        {
            if (this.ItemsOnDemand == null)
            {
                this.ItemsOnDemand = new ObservableCollection<FolderViewModel>(from f in this.folderElement.Elements("folder")
                                                                               select new FolderViewModel(
                                                                               f.Attribute("Name").Value,
                                                                               bool.Parse(f.Attribute("IsEmpty").Value),
																			   DateTime.Parse(f.Attribute("CreationTime").Value, System.Globalization.CultureInfo.InvariantCulture),
                                                                               f
                                                                           ));
            }
        }
    }
}
