﻿using System;
using System.Windows;
using System.Xml;
using System.Linq;
using System.Xml.Linq;
using System.Collections.ObjectModel;

namespace Telerik.Windows.Examples.TreeListView
{
	public class MyDataContext
	{
		ObservableCollection<FolderViewModel> _folders;

		public ObservableCollection<FolderViewModel> Folders
		{
			get
			{
				if (_folders == null)
				{
					var stream = Application.GetResourceStream(new Uri("SilverlightApplication1;component/Folders.xml",
																	   UriKind.RelativeOrAbsolute)).Stream;
					var reader = XmlReader.Create(stream);
					var document = XDocument.Load(reader);

					var data = from f in document.Element("folders").Elements("folder")
							   select new FolderViewModel(f.Attribute("Name").Value,
														  bool.Parse(f.Attribute("IsEmpty").Value),
														  DateTime.Parse(f.Attribute("CreationTime").Value, System.Globalization.CultureInfo.InvariantCulture),
														  f);

					_folders = new ObservableCollection<FolderViewModel>(data);
				}

				return _folders;
			}
		}
	}
}
